------------------------------------------------------------------------------------------------------------------------------------------
-- ADDON DECLARATION
------------------------------------------------------------------------------------------------------------------------------------------
local addon, addonTable = ...
local tempVariable = {}
local event_frame, events = CreateFrame("FRAME", "event_frame"), {}
local LibItemLevel = LibStub:GetLibrary("LibItemLevel.7000")
local jeton
if GetLocale() == "frFR" then loc_detected = "détecté" loc_arti_power = "*PP*" loc_consumable = "Consommable" loc_other = "Autre" loc_reinforcement = "Renforcement" loc_kicked = "interrompu" loc_notboss = "Vous devez être leader ou assistant pour effectuer un readycheck !" else loc_garrison_chest = "Garrison cache" loc_detected = "detected" loc_arti_power = "*AP*" loc_consumable = "Consumable" loc_other = "Other" loc_reinforcement = "Reinforcement" loc_kicked = "interrupted" loc_notboss = "You have to be leader or assistant to perform ready check !" end
------------------------------------------------------------------------------------------------------------------------------------------
-- CVARS
------------------------------------------------------------------------------------------------------------------------------------------
-- Action Bars
SetCVar("ActionButtonUseKeyDown", 1)
SetCVar("countdownForCooldowns", 1)
SetCVar("lockActionBars", 1)
SetCVar("xpBarText", 1)
-- Camera View
SetCVar("cameraDistanceMaxZoomFactor", 2.6)
SetCVar("cameraSmoothStyle", 0)
SetCVar("findYourselfAnywhere", 0)
SetCVar("findYourselfMode", 1)
-- Chat
SetCVar("chatBubbles", 1)
SetCVar("chatBubblesParty", 0)
SetCVar("colorChatNamesByClass", 1)
SetCVar("guildMemberNotify", 1)
SetCVar("profanityFilter", 0)
SetCVar("spamFilter", 1)
SetCVar("whisperMode", "inline")
-- Loading
SetCVar("worldPreloadNonCritical", 0)
-- Floating Combat Text
SetCVar("enableFloatingCombatText", 1)
SetCVar("floatingCombatTextAuras", 0)
SetCVar("floatingCombatTextCombatDamageDirectionalScale", 0)
SetCVar("floatingCombatTextCombatHealing", 0)
SetCVar("floatingCombatTextCombatHealingAbsorbSelf", 0)
SetCVar("floatingCombatTextCombatHealingAbsorbTarget", 0)
SetCVar("floatingCombatTextCombatLogPeriodicSpells", 0)
SetCVar("floatingCombatTextCombatState", 0)
SetCVar("floatingCombatTextDamageReduction", 0)
SetCVar("floatingCombatTextDodgeParryMiss", 0)
SetCVar("floatingCombatTextEnergyGains", 0)
SetCVar("floatingCombatTextFloatMode", "2")
SetCVar("floatingCombatTextFriendlyHealers", 1)
SetCVar("floatingCombatTextHonorGains", 0)
SetCVar("floatingCombatTextPeriodicEnergyGains", 0)
SetCVar("floatingCombatTextPetMeleeDamage", 0)
SetCVar("floatingCombatTextReactives", 0)
SetCVar("floatingCombatTextRepChanges", 1)
SetCVar("floatingCombatTextSpellMechanics", 0)
-- Loot and bags
SetCVar("alwaysCompareItems", 1)
SetCVar("displayFreeBagSlots", 1)
SetCVar("autoLootDefault", 1)
-- Map and minimap
SetCVar("mapFade", 0)
SetCVar("rotateMinimap", 1)
-- Nameplates and Targeting
SetCVar("deselectOnClick", 1)
SetCVar("nameplateMaxDistance", 40)
SetCVar("nameplateOtherAtBase", 0)
SetCVar("nameplateOtherBottomInset", -1)
SetCVar("nameplateOthertopInset", -1)
-- Quests
SetCVar("trackQuestSorting", "proximity")
-- Sound
SetCVar("Sound_EnableSoundWhenGameIsInBG", 1)
SetCVar("Sound_MasterVolume", 1)
SetCVar("Sound_EnableMusic", 0)
SetCVar("Sound_EnableSFX", 1)
-- Unit Frames
SetCVar("raidFramesDisplayClassColor", 1)
SetCVar("raidFramesDisplayOnlyDispellableDebuffs", 1)
SetCVar("raidOptionKeepGroupsTogether", 1)
SetCVar("showTargetOfTarget", 1)
SetCVar("useCompactPartyFrames", 1)
SetCVar("statusText", 1)
SetCVar("statusTextDisplay", "BOTH")
SetCVar("threatShowNumeric", 1)
------------------------------------------------------------------------------------------------------------------------------------------
-- COMMANDS
------------------------------------------------------------------------------------------------------------------------------------------
-- fps frame
do _G.FramerateLabel:ClearAllPoints() _G.FramerateLabel:SetPoint("BOTTOMLEFT", _G.UIParent, "BOTTOMLEFT", 0, 0) _G.FramerateLabel:Hide() _G.FramerateText:ClearAllPoints() _G.FramerateText:SetPoint("LEFT", _G.FramerateLabel, "RIGHT") _G.FramerateText:Hide() end
-- screen grid frame
local grid, gridSize = CreateFrame("FRAME", "grid", _G.UIParent), 64 grid:SetAllPoints(_G.UIParent) grid:Hide() for i = 0, gridSize do local column = GetScreenWidth() / gridSize local line = GetScreenHeight() / gridSize local horizontal = grid:CreateTexture(nil, "BACKGROUND") local vertical = grid:CreateTexture(nil, "BACKGROUND") if i == gridSize*.75 or i == gridSize*.5 or i == gridSize*.25 then horizontal:SetColorTexture(1, 0, 0, 0.5) vertical:SetColorTexture(1, 0, 0, 0.5) else horizontal:SetColorTexture(0, 0, 0, 0.1) vertical:SetColorTexture(0, 0, 0, 0.1) end horizontal:SetPoint("TOPLEFT", grid, "TOPLEFT", i*column-1, 0) horizontal:SetPoint("BOTTOMRIGHT", grid, "BOTTOMLEFT", i*column+1, 0) vertical:SetPoint("TOPLEFT", grid, "TOPLEFT", 0, -i*line+1) vertical:SetPoint("BOTTOMRIGHT", grid, "TOPRIGHT", 0, -i*line-1) end
--
local function LuaDebugOn() SetCVar("scriptErrors", 1) print("scriptErrors enabled") end
--
local function LuaDebugOff() SetCVar("scriptErrors", 0) print("scriptErrors disabled") end
--
local function ShowScreenGrid() grid:Show() end
--
local function HideScreenGrid() grid:Hide() end
--
local function AskIfReady() if UnitIsGroupLeader("player") or UnitIsGroupAssistant("player") then DoReadyCheck() else print(loc_notboss) end end
--
_G.SLASH_MATHO1 = "/matho"
--
SlashCmdList.MATHO = function(option) if option == "rl" then ReloadUI() elseif option == "debugon" then LuaDebugOn() elseif option == "debugoff" then LuaDebugOff() elseif option == "fps" then ToggleFramerate() elseif option == "gridon" then ShowScreenGrid() elseif option == "gridoff" then HideScreenGrid() elseif option == "rc" then AskIfReady() else print("MathoUI commands :") print("\/matho rl = reload ui") print("\/matho debugon = enable lua debug") print("\/matho debugoff = disable lua debug") print("\/matho fps = toggle fps") print("\/matho gridon = show screen grid") print("\/matho gridoff = hide screen grid") print("\/matho rc = perform ready check") end end
------------------------------------------------------------------------------------------------------------------------------------------
-- AUTOMATE QUESTS : AUTO ACCEPT SELECTED QUEST, SKIP GOSSIP AND AUTO COMPLETE, TEMPORARY DISABLE WITH PRESS SHIFT KEY
------------------------------------------------------------------------------------------------------------------------------------------
local function QuestAcceptConfirm() if IsShiftKeyDown() then return else ConfirmAcceptQuest() StaticPopup_Hide("QUEST_ACCEPT") end end
--
local function QuestAutocomplete() if IsShiftKeyDown() then return else if GetNumAutoQuestPopUps() > 0 then local questId, questType = GetAutoQuestPopUp(1) if questType == "COMPLETE" then local index = GetQuestLogIndexByID(questId) ShowQuestComplete(index) end end end end
--
local function QuestComplete() if IsShiftKeyDown() then return else if GetNumQuestChoices() <= 1 then GetQuestReward(GetNumQuestChoices()) end end end
--
local function QuestDetail() if IsShiftKeyDown() then return else if QuestGetAutoAccept() then C_Timer.After(math.max(1, 0.01), CloseQuest) else C_Timer.After(math.max(1, 0.01), AcceptQuest) end end end
--
local function QuestGreeting() if IsShiftKeyDown() then return else if UnitExists("npc") or _G.QuestFrameGreetingPanel:IsShown() then local numAvailable = GetNumAvailableQuests() or 0 local numActive = GetNumActiveQuests() or 0 if numAvailable >= 1 then for i = 1, numAvailable do SelectAvailableQuest(i) end end if numActive >= 1 then for i = 1, numActive do local _, isComplete = GetActiveTitle(i) if isComplete then SelectActiveQuest(i) end end end end end end
--
local function QuestProgress() if IsShiftKeyDown() then return else if IsQuestCompletable() then CompleteQuest() end end end
--
function events:QUEST_ACCEPT_CONFIRM(...) QuestAcceptConfirm() end
--
function events:QUEST_AUTOCOMPLETE(...) QuestAutocomplete() end
--
function events:QUEST_COMPLETE(...) QuestComplete() end
--
function events:QUEST_DETAIL(...) QuestDetail() end
--
function events:QUEST_GREETING(...) QuestGreeting() end
--
function events:QUEST_PROGRESS(...) QuestProgress() end
------------------------------------------------------------------------------------------------------------------------------------------
-- CHAT AS TO RAID WARNING
------------------------------------------------------------------------------------------------------------------------------------------
local function SendAs(message, sender, canal, sound) local name = string.gsub(sender, "-%"..string.gsub(GetRealmName(), " ", ""), "") RaidNotice_AddMessage(_G.RaidWarningFrame, "\\"..canal.." ["..date("%H:%M").." "..name.."] "..message, _G.ChatTypeInfo[canal]) if sound ~= nil then PlaySoundFile(sound, "Master") end end
--
function events:CHAT_MSG_GUILD(...) SendAs(select(1, ...), select(5, ...), "GUILD", "Interface\\AddOns\\mathoUI2\\Medias\\Sounds\\_chat_g.ogg") end
--
function events:CHAT_MSG_OFFICER(...) SendAs(select(1, ...), select(5, ...), "GUILD", "Interface\\AddOns\\mathoUI2\\Medias\\Sounds\\_chat_g.ogg") end
--
function events:CHAT_MSG_INSTANCE_CHAT(...) SendAs(select(1, ...), select(5, ...), "PARTY", "Interface\\AddOns\\mathoUI2\\Medias\\Sounds\\_chat_i.ogg") end
--
function events:CHAT_MSG_INSTANCE_CHAT_LEADER(...) SendAs(select(1, ...), select(5, ...), "PARTY", "Interface\\AddOns\\mathoUI2\\Medias\\Sounds\\_chat_i.ogg") end
--
function events:CHAT_MSG_PARTY(...) SendAs(select(1, ...), select(5, ...), "PARTY", "Interface\\AddOns\\mathoUI2\\Medias\\Sounds\\_chat_i.ogg") end
--
function events:CHAT_MSG_PARTY_LEADER(...) SendAs(select(1, ...), select(5, ...), "PARTY", "Interface\\AddOns\\mathoUI2\\Medias\\Sounds\\_chat_i.ogg") end
--
function events:CHAT_MSG_RAID(...) SendAs(select(1, ...), select(5, ...), "RAID", "Interface\\AddOns\\mathoUI2\\Medias\\Sounds\\_chat_i.ogg") end
--
function events:CHAT_MSG_RAID_LEADER(...) SendAs(select(1, ...), select(5, ...), "RAID", "Interface\\AddOns\\mathoUI2\\Medias\\Sounds\\_chat_i.ogg") end
--
function events:CHAT_MSG_BN_CONVERSATION(...) SendAs(select(1, ...), select(5, ...), "BN_WHISPER", "Interface\\AddOns\\mathoUI2\\Medias\\Sounds\\_chat_w.ogg") end
--
function events:CHAT_MSG_BN_INLINE_TOAST_BROADCAST(...) SendAs(select(1, ...), select(5, ...), "BN_WHISPER", "Interface\\AddOns\\mathoUI2\\Medias\\Sounds\\_chat_w.ogg") end
--
function events:CHAT_MSG_BN_WHISPER(...) SendAs(select(1, ...), select(5, ...), "BN_WHISPER", "Interface\\AddOns\\mathoUI2\\Medias\\Sounds\\_chat_w.ogg") end
--
function events:CHAT_MSG_WHISPER(...) SendAs(select(1, ...), select(5, ...), "WHISPER", "Interface\\AddOns\\mathoUI2\\Medias\\Sounds\\_chat_w.ogg") end
------------------------------------------------------------------------------------------------------------------------------------------
-- ITEM LEVEL & ID
------------------------------------------------------------------------------------------------------------------------------------------
local function ShowPaperDollItemLevel(self, unit) local id = self:GetID() if id == 4 or id > 17 then return end if not self.levelString then self.levelString = self:CreateFontString(nil, "OVERLAY") self.levelString:SetFont(_G.STANDARD_TEXT_FONT, 14, "OUTLINE") self.levelString:SetPoint("TOP") self.levelString:SetTextColor(1, 0.82, 0) end local result if unit and self.hasItem then local _, level, _, _, quality = LibItemLevel:GetUnitItemInfo(unit, id) if level > 0 and quality > 2 then self.levelString:SetText(level) result = true end else self.levelString:SetText("") result = true end if id == 16 or id == 17 then local _, offhand, _, _, quality = LibItemLevel:GetUnitItemInfo(unit, 17) if quality == 6 then local _, mainhand = LibItemLevel:GetUnitItemInfo(unit, 16) self.levelString:SetText(math.max(mainhand, offhand)) end end return result end
--
local function SetContainerItemLevel(button, ItemLink) if not button then return end if not button.levelString then button.levelString = button:CreateFontString(nil, "OVERLAY") button.levelString:SetFont(_G.STANDARD_TEXT_FONT, 14, "THICKOUTLINE") button.levelString:SetPoint("TOP") end if button.origItemLink ~= ItemLink then button.origItemLink = ItemLink else return end if ItemLink then local count, level, _, _, quality, _, _, class, subclass, _, _ = LibItemLevel:GetItemInfo(ItemLink) local name, _ = GetItemSpell(ItemLink) local _, equipped, _ = GetAverageItemLevel() if level >= (98 * equipped / 100) then button.levelString:SetTextColor(1, 0, 0) else button.levelString:SetTextColor(1, 1, 1) end if count == 0 and level > 0 and quality > 1 then button.levelString:SetText(level) else button.levelString:SetText("") end if class == loc_consumable and subclass == loc_other and name == loc_reinforcement then button.levelString:SetTextColor(0, 1, 0) button.levelString:SetText(loc_arti_power) end else button.levelString:SetText("") end end
--
local function ShowTooltipIdInfo(self, id, label) local text, found for i = 2, self:NumLines() do text = _G[self:GetName() .. "TextLeft" .. i]:GetText() or "" if string.find(text, id) then found = true break end end if not found then self:AddLine(" ") self:AddLine(label..id, 0.25, 0.8, 0.6) self:Show() end end
--
hooksecurefunc("PaperDollItemSlotButton_Update", function(self) ShowPaperDollItemLevel(self, "player") end)
--
hooksecurefunc("ContainerFrame_Update", function(self) local id = self:GetID() local name = self:GetName() local button for i = 1, self.size do button = _G[name.."Item"..i] SetContainerItemLevel(button, GetContainerItemLink(id, button:GetID())) end end)
--
hooksecurefunc("SetItemRef", function(link) local _, id = strsplit(":", link or "") if id then ShowTooltipIdInfo(_G.ItemRefTooltip, id, "ItemID: ") end end)
--
_G.GameTooltip:HookScript("OnTooltipSetSpell", function(self) local id = select(3, self:GetSpell()) if id then ShowTooltipIdInfo(self, id, "SpellID: ") end end)
--
_G.GameTooltip:HookScript("OnTooltipSetItem", function(self) local item = select(2, self:GetItem()) if item then local _, id = strsplit(":", item) if id then ShowTooltipIdInfo(self, id, "ItemID: ") end end end)
------------------------------------------------------------------------------------------------------------------------------------------
-- MISC
------------------------------------------------------------------------------------------------------------------------------------------
local function Repair() local repairAllCost, canRepair = GetRepairAllCost() if CanMerchantRepair() and canRepair and repairAllCost > 0 then RepairAllItems() end end
--
local function Sell() jeton = C_Timer.NewTicker(math.max(1, 0.01), function() for BagID = 0, 4 do for BagSlot = 1, GetContainerNumSlots(BagID) do local itemToSold = GetContainerItemLink(BagID, BagSlot) if itemToSold then local _, _, qualite, _, _, _, _, _, _, _, prix = GetItemInfo(itemToSold) if _G.MerchantFrame:IsShown() and qualite == 0 and prix ~= 0 then UseContainerItem(BagID, BagSlot) end end end end end, 200) end
--
local function StopSellLoop() if jeton then jeton:Cancel() end end
--
local function OpenMails() local numItems, totalItems = GetInboxNumItems() if totalItems == 0 then return elseif numItems > 0 then local _, _, _, _, _, payToLoot, _, _, _, _, _, _, isGM, _ = GetInboxHeaderInfo(numItems) if not (payToLoot > 0 or isGM) then AutoLootMailItem(numItems) end end end
--
local function Learn() jeton = C_Timer.NewTicker(math.max(1, 0.01), function() if IsTradeskillTrainer() then SetTrainerServiceTypeFilter("available", 1, 1) for i = 1, GetNumTrainerServices() do BuyTrainerService(i) end end end, 200) end
--
local function StopLearnLoop() if jeton then jeton:Cancel() end end
--
local function FasterLooting() local delay = 0 if GetTime() - delay >= 0.3 then delay = GetTime() if GetCVarBool("autoLootDefault") ~= IsModifiedClick("AUTOLOOTTOGGLE") then for i = GetNumLootItems(), 1, -1 do LootSlot(i) end delay = GetTime() end end end
--
local function AnnounceRareAndTreasure(rareID) if rareID then local _, _, name = _G.C_Vignettes.GetVignetteInfoFromInstanceID(rareID) if name ~= nil and name ~= loc_garrison_chest then local message = "|cff00ff00"..name.." "..loc_detected.."!|r" RaidNotice_AddMessage(_G.RaidWarningFrame, message, _G.ChatTypeInfo["RAID_WARNING"]) PlaySoundFile("Interface\\AddOns\\mathoUI2\\Medias\\Sounds\\_rare_and_treasure.ogg", "Master") end end end
--
local function ConfirmRoll(arg1, arg2) ConfirmLootRoll(arg1, arg2) StaticPopup_Hide("CONFIRM_LOOT_ROLL") end
--
local function ConfirmBop(arg1, arg2) ConfirmLootSlot(arg1, arg2) StaticPopup_Hide("LOOT_BIND") end
--
local function AutoReleasePvP() local InstStat, InstType = IsInInstance() if InstStat and InstType == "pvp" and not HasSoulstone() then RepopMe() end end
--
local function AcceptSummon() if not UnitAffectingCombat("player") then ConfirmSummon() StaticPopup_Hide("CONFIRM_SUMMON") end end
--
local function InterruptAnnouncer(spell, canal, word) SendChatMessage(GetSpellLink(spell).." "..tostring(word), canal) end
--
function events:PLAYER_ENTERING_WORLD(...) if (_G.instanceType == "pvp" or _G.instanceType == "arena") and not _G.ObjectiveTrackerFrame.collapsed then ObjectiveTracker_Collapse() end end
--
function events:CONFIRM_DISENCHANT_ROLL(...) ConfirmRoll(select(1, ...), select(2, ...)) end
--
function events:CONFIRM_LOOT_ROLL(...) ConfirmRoll(select(1, ...), select(2, ...)) end
--
function events:LOOT_BIND_CONFIRM(...) ConfirmBop() end
--
function events:LOOT_READY(...) FasterLooting() end
--
function events:MAIL_INBOX_UPDATE(...) OpenMails() end
--
function events:MERCHANT_CLOSED(...) StopSellLoop() end
--
function events:MERCHANT_SHOW(...) Repair() Sell() end
--
function events:PLAYER_DEAD(...) AutoReleasePvP() end
--
function events:TRAINER_CLOSED(...) StopLearnLoop() end
--
function events:TRAINER_SHOW(...) Learn() end
--
function events:VIGNETTE_ADDED(...) AnnounceRareAndTreasure(select(1, ...)) end
--
function events:CONFIRM_SUMMON(...) AcceptSummon() end
--
function events:COMBAT_LOG_EVENT_UNFILTERED(...) local _, action, _, _, sourceName, _, _, _, _, _, _, _, _, _, amount, _, _, _, _, _, _, _, _ = ... if action == "SPELL_INTERRUPT" and (sourceName == UnitName("player") or sourceName == UnitName("pet")) then if IsInRaid() then InterruptAnnouncer(amount, "RAID", loc_kicked) elseif IsInGroup() then InterruptAnnouncer(amount, "PARTY", loc_kicked) end end end
------------------------------------------------------------------------------------------------------------------------------------------
-- HANDLER
------------------------------------------------------------------------------------------------------------------------------------------
event_frame:SetScript("OnEvent", function(self, event, ...) events[event](self, ...) end )
for k, _ in pairs(events) do event_frame:RegisterEvent(k) end