------------------------------------------------------------------------------------------------------------------------------------------
-- ADDON DECLARATIONS
------------------------------------------------------------------------------------------------------------------------------------------
local addon, addonTable = ...
local event_frame = CreateFrame("FRAME", "event_frame")
local hidden_frame = CreateFrame("FRAME", "hidden_frame")
hidden_frame:Hide()
------------------------------------------------------------------------------------------------------------------------------------------
-- MOVE ELEMENT
------------------------------------------------------------------------------------------------------------------------------------------
function MoveElement(frame, parent, anchTo , relative, anchFrm, xpos, ypos, scale) if parent ~= nil then frame:SetParent(parent) end frame:ClearAllPoints() frame:SetPoint(anchTo , relative, anchFrm, xpos, ypos) if scale ~= nil then frame:SetScale(scale) end end
------------------------------------------------------------------------------------------------------------------------------------------
-- BEAUTIFY BARS
------------------------------------------------------------------------------------------------------------------------------------------
-- Clean bar elements (exhaustive list)
for _, f in next, {_G.ActionBarDownButton, _G.ActionBarUpButton, _G.MainMenuBarLeftEndCap, _G.MainMenuBarPageNumber, _G.MainMenuBarRightEndCap, _G.MainMenuBarTexture0, _G.MainMenuBarTexture1, _G.MainMenuBarTexture2, _G.MainMenuBarTexture3, _G.MainMenuMaxLevelBar0, _G.MainMenuMaxLevelBar1, _G.MainMenuMaxLevelBar2, _G.MainMenuMaxLevelBar3, _G.MainMenuXPBarTextureLeftCap, _G.MainMenuXPBarTextureMid, _G.MainMenuXPBarTextureRightCap, _G.PossessBackground1, _G.PossessBackground2, _G.SlidingActionBarTexture0, _G.SlidingActionBarTexture1, _G.StanceBarLeft, _G.StanceBarMiddle, _G.StanceBarRight, _G.ReputationWatchBar.StatusBar.WatchBarTexture0, _G.ReputationWatchBar.StatusBar.WatchBarTexture1, _G.ReputationWatchBar.StatusBar.WatchBarTexture2, _G.ReputationWatchBar.StatusBar.WatchBarTexture3, _G.ReputationWatchBar.StatusBar.XPBarTexture0, _G.ReputationWatchBar.StatusBar.XPBarTexture1, _G.ReputationWatchBar.StatusBar.XPBarTexture2, _G.ReputationWatchBar.StatusBar.XPBarTexture3, _G.MainMenuXPBarDiv1, _G.MainMenuXPBarDiv2, _G.MainMenuXPBarDiv3, _G.MainMenuXPBarDiv4, _G.MainMenuXPBarDiv5, _G.MainMenuXPBarDiv6, _G.MainMenuXPBarDiv7, _G.MainMenuXPBarDiv8, _G.MainMenuXPBarDiv9, _G.MainMenuXPBarDiv10, _G.MainMenuXPBarDiv11, _G.MainMenuXPBarDiv12, _G.MainMenuXPBarDiv13, _G.MainMenuXPBarDiv14, _G.MainMenuXPBarDiv15, _G.MainMenuXPBarDiv16, _G.MainMenuXPBarDiv17, _G.MainMenuXPBarDiv18, _G.MainMenuXPBarDiv19, _G.ArtifactWatchBar.StatusBar.WatchBarTexture0, _G.ArtifactWatchBar.StatusBar.XPBarTexture0, _G.HonorWatchBar.StatusBar.WatchBarTexture0, _G.HonorWatchBar.StatusBar.XPBarTexture0, _G.ArtifactWatchBar.StatusBar.WatchBarTexture1, _G.ArtifactWatchBar.StatusBar.XPBarTexture1, _G.HonorWatchBar.StatusBar.WatchBarTexture1, _G.HonorWatchBar.StatusBar.XPBarTexture1, _G.ArtifactWatchBar.StatusBar.WatchBarTexture2, _G.ArtifactWatchBar.StatusBar.XPBarTexture2, _G.HonorWatchBar.StatusBar.WatchBarTexture2, _G.HonorWatchBar.StatusBar.XPBarTexture2, _G.ArtifactWatchBar.StatusBar.WatchBarTexture3, _G.ArtifactWatchBar.StatusBar.XPBarTexture3, _G.HonorWatchBar.StatusBar.WatchBarTexture3, _G.HonorWatchBar.StatusBar.XPBarTexture3, _G.ActionButton1NormalTexture, _G.MultiBarBottomLeftButton1NormalTexture, _G.MultiBarBottomLeftButton1FloatingBG, _G.MultiBarBottomRightButton1NormalTexture, _G.MultiBarBottomRightButton1FloatingBG, _G.MultiBarLeftButton1NormalTexture, _G.MultiBarLeftButton1FloatingBG, _G.MultiBarRightButton1NormalTexture, _G.MultiBarRightButton1FloatingBG, _G.ActionButton2NormalTexture, _G.MultiBarBottomLeftButton2NormalTexture, _G.MultiBarBottomLeftButton2FloatingBG, _G.MultiBarBottomRightButton2NormalTexture, _G.MultiBarBottomRightButton2FloatingBG, _G.MultiBarLeftButton2NormalTexture, _G.MultiBarLeftButton2FloatingBG, _G.MultiBarRightButton2NormalTexture, _G.MultiBarRightButton2FloatingBG, _G.ActionButton3NormalTexture, _G.MultiBarBottomLeftButton3NormalTexture, _G.MultiBarBottomLeftButton3FloatingBG, _G.MultiBarBottomRightButton3NormalTexture, _G.MultiBarBottomRightButton3FloatingBG, _G.MultiBarLeftButton3NormalTexture, _G.MultiBarLeftButton3FloatingBG, _G.MultiBarRightButton3NormalTexture, _G.MultiBarRightButton3FloatingBG, _G.ActionButton4NormalTexture, _G.MultiBarBottomLeftButton4NormalTexture, _G.MultiBarBottomLeftButton4FloatingBG, _G.MultiBarBottomRightButton4NormalTexture, _G.MultiBarBottomRightButton4FloatingBG, _G.MultiBarLeftButton4NormalTexture, _G.MultiBarLeftButton4FloatingBG, _G.MultiBarRightButton4NormalTexture, _G.MultiBarRightButton4FloatingBG, _G.ActionButton5NormalTexture, _G.MultiBarBottomLeftButton5NormalTexture, _G.MultiBarBottomLeftButton5FloatingBG, _G.MultiBarBottomRightButton5NormalTexture, _G.MultiBarBottomRightButton5FloatingBG, _G.MultiBarLeftButton5NormalTexture, _G.MultiBarLeftButton5FloatingBG, _G.MultiBarRightButton5NormalTexture, _G.MultiBarRightButton5FloatingBG, _G.ActionButton6NormalTexture, _G.MultiBarBottomLeftButton6NormalTexture, _G.MultiBarBottomLeftButton6FloatingBG, _G.MultiBarBottomRightButton6NormalTexture, _G.MultiBarBottomRightButton6FloatingBG, _G.MultiBarLeftButton6NormalTexture, _G.MultiBarLeftButton6FloatingBG, _G.MultiBarRightButton6NormalTexture, _G.MultiBarRightButton6FloatingBG, _G.ActionButton7NormalTexture, _G.MultiBarBottomLeftButton7NormalTexture, _G.MultiBarBottomLeftButton7FloatingBG, _G.MultiBarBottomRightButton7NormalTexture, _G.MultiBarBottomRightButton7FloatingBG, _G.MultiBarLeftButton7NormalTexture, _G.MultiBarLeftButton7FloatingBG, _G.MultiBarRightButton7NormalTexture, _G.MultiBarRightButton7FloatingBG, _G.ActionButton8NormalTexture, _G.MultiBarBottomLeftButton8NormalTexture, _G.MultiBarBottomLeftButton8FloatingBG, _G.MultiBarBottomRightButton8NormalTexture, _G.MultiBarBottomRightButton8FloatingBG, _G.MultiBarLeftButton8NormalTexture, _G.MultiBarLeftButton8FloatingBG, _G.MultiBarRightButton8NormalTexture, _G.MultiBarRightButton8FloatingBG, _G.ActionButton9NormalTexture, _G.MultiBarBottomLeftButton9NormalTexture, _G.MultiBarBottomLeftButton9FloatingBG, _G.MultiBarBottomRightButton9NormalTexture, _G.MultiBarBottomRightButton9FloatingBG, _G.MultiBarLeftButton9NormalTexture, _G.MultiBarLeftButton9FloatingBG, _G.MultiBarRightButton9NormalTexture, _G.MultiBarRightButton9FloatingBG, _G.ActionButton10NormalTexture, _G.MultiBarBottomLeftButton10NormalTexture, _G.MultiBarBottomLeftButton10FloatingBG, _G.MultiBarBottomRightButton10NormalTexture, _G.MultiBarBottomRightButton10FloatingBG, _G.MultiBarLeftButton10NormalTexture, _G.MultiBarLeftButton10FloatingBG, _G.MultiBarRightButton10NormalTexture, _G.MultiBarRightButton10FloatingBG, _G.ActionButton11NormalTexture, _G.MultiBarBottomLeftButton11NormalTexture, _G.MultiBarBottomLeftButton11FloatingBG, _G.MultiBarBottomRightButton11NormalTexture, _G.MultiBarBottomRightButton11FloatingBG, _G.MultiBarLeftButton11NormalTexture, _G.MultiBarLeftButton11FloatingBG, _G.MultiBarRightButton11NormalTexture, _G.MultiBarRightButton11FloatingBG, _G.ActionButton12NormalTexture, _G.MultiBarBottomLeftButton12NormalTexture, _G.MultiBarBottomLeftButton12FloatingBG, _G.MultiBarBottomRightButton12NormalTexture, _G.MultiBarBottomRightButton12FloatingBG, _G.MultiBarLeftButton12NormalTexture, _G.MultiBarLeftButton12FloatingBG, _G.MultiBarRightButton12NormalTexture, _G.MultiBarRightButton12FloatingBG, _G.GameTimeFrame, _G.MiniMapWorldMapButton, _G.MinimapBorderTop, _G.MinimapZoomIn, _G.MinimapZoomOut, _G.MiniMapTrackingBackground, _G.MiniMapTrackingButtonBorder, _G.QueueStatusMinimapButtonBorder, _G.MiniMapMailBorder,} do f:SetParent(hidden_frame) f:SetAlpha(0) f:Hide() end
-- Modify main bar
_G.MainMenuBar:SetWidth(128) _G.MainMenuBar:SetScale(0.6)
MoveElement(_G.ActionButton1, nil, "CENTER", _G.UIParent, "CENTER", -(_G.ActionButton1:GetWidth() + 2.5) * 6, -300, nil)
-- Modify multi bar
MoveElement(_G.MultiBarBottomLeftButton1, nil, "CENTER", _G.UIParent, "CENTER", -(_G.ActionButton1:GetWidth() + 2.5) * 6, -300 + _G.ActionButton1:GetHeight() + 4, nil)
MoveElement(_G.MultiBarBottomRightButton1, nil, "CENTER", _G.UIParent, "CENTER", -(_G.ActionButton1:GetWidth() + 2.5) * 6, -300 + 2 * (_G.ActionButton1:GetHeight() + 4), nil)
MoveElement(_G.MultiBarRightButton1, nil, "TOPRIGHT", _G.MultiBarRight, "TOPRIGHT", 0, 100, nil)
MoveElement(_G.MultiBarLeftButton1, nil, "TOPRIGHT", _G.MultiBarLeft, "TOPRIGHT", 0, 100, nil)
-- Modify micro bar
hooksecurefunc("UpdateMicroButtons", function() MoveElement(_G.CharacterMicroButton, _nil, "BOTTOM", _G.UIParent, "BOTTOM", -_G.ActionButton1:GetWidth() * 6, 0, nil)  end)
-- Modify bag bar
MoveElement(_G.MainMenuBarBackpackButton, nil, "BOTTOM", _G.UIParent, "BOTTOM", 210, 4, nil)
-- Modify xp bar
for _, f in next, { _G.MainMenuExpBar, _G.MainMenuBarMaxLevelBar, _G.ReputationWatchBar, _G.ReputationWatchBar.StatusBar, _G.HonorWatchBar, _G.HonorWatchBar.StatusBar, _G.ArtifactWatchBar, _G.ArtifactWatchBar.StatusBar, } do f:SetWidth(_G.MainMenuBar:GetWidth() * 4 - 12) end
_G.MainMenuExpBar:SetHeight(4) _G.ExhaustionLevelFillBar:SetHeight(4)
hooksecurefunc("MainMenuTrackingBar_Configure", 	function(frame, isOnTop) MoveElement(_G.MainMenuExpBar, nil, "CENTER", _G.MainMenuBar, "CENTER", 0, 0, nil) frame.StatusBar:SetHeight(4) if isOnTop then frame.OverlayFrame.Text:SetPoint("CENTER", frame.OverlayFrame, "CENTER", 0, 5) for _, f in next, {_G.ArtifactWatchBar, _G.HonorWatchBar, _G.ReputationWatchBar} do f.OverlayFrame.Text:SetPoint("CENTER", f.OverlayFrame, "CENTER", 0, 3) end else frame.OverlayFrame.Text:SetPoint("CENTER", frame.OverlayFrame, "CENTER", 0, 3) end end)
hooksecurefunc("MainMenuBar_UpdateExperienceBars", function() local _, reaction, _, _, _, factionID = GetWatchedFactionInfo() local friendTextLevel = select(7, GetFriendshipReputation(factionID)) local levelText = friendTextLevel or GetText("FACTION_STANDING_LABEL"..reaction) if _G.ReputationWatchBar.OverlayFrame.Text:GetText() then _G.ReputationWatchBar.OverlayFrame.Text:SetText(_G.ReputationWatchBar.OverlayFrame.Text:GetText().." "..levelText) end if _G.ArtifactWatchBar:IsShown() or _G.HonorWatchBar:IsShown() or _G.ReputationWatchBar:IsShown() then _G.MainMenuBarExpText:SetPoint( "CENTER", _G.MainMenuExpBar, 0 , 0) else _G.MainMenuBarExpText:SetPoint("CENTER", _G.MainMenuExpBar, 0 , 0) end end) 

 if ((HasVehicleActionBar() and UnitVehicleSkin("player") and UnitVehicleSkin("player") ~= "")     or (HasOverrideActionBar() and GetOverrideBarSkin() and GetOverrideBarSkin() ~= "")) then _G.OverrideActionBar:SetScale(0.6) end
-- Modify extra button
MoveElement(_G.ExtraActionBarFrame, _G.UIParent, "BOTTOM", _G.UIParent, "BOTTOM", 400, 0, .5)
_G.ExtraActionBarFrame.SetPoint = function() end
-- Modify Zone Ability button
MoveElement(_G.ZoneAbilityFrame, _G.UIParent, "BOTTOM", _G.UIParent, "BOTTOM", -400, 0, .5)
_G.ZoneAbilityFrame.SetPoint = function() end
-- Casting bar
CastingBarFrame:HookScript("OnShow", function(self) self:ClearAllPoints() self:SetPoint("CENTER", UIParent, "CENTER", 0, -198) self:SetWidth(296) self:SetHeight(6) self.Border:Hide(0) self.BorderShield:Hide(0) self.Flash:Hide(0) self.Flash:SetAlpha(0) self.Flash:SetTexture(nil) self.SetPoint = function() end end)
-- AVOID BLIZZ OVERRIDING
local function OverridePosit() if InCombatLockdown() then return end local PET_X, PET_Y if not _G.SHOW_MULTI_ACTIONBAR_1 and not _G.SHOW_MULTI_ACTIONBAR_2 then PET_Y = 0 elseif _G.SHOW_MULTI_ACTIONBAR_1 and not _G.SHOW_MULTI_ACTIONBAR_2 then PET_Y = _G.ActionButton1:GetHeight() + 6 else PET_Y = 2 * _G.ActionButton1:GetHeight() + 6 end if _G.StanceBarFrame and GetNumShapeshiftForms() > 0 then PET_X = 127 else PET_X = 127/2 end MoveElement(_G.PetActionButton1, nil, "BOTTOMLEFT", _G.MultiBarBottomLeftButton1, "BOTTOMLEFT", PET_X, PET_Y, nil) MoveElement(_G.StanceButton1, nil, "BOTTOMLEFT", _G.MultiBarBottomLeftButton1, "BOTTOMLEFT", 0, PET_Y, nil) MoveElement(_G.PossessButton1, nil, "BOTTOMLEFT", _G.MultiBarBottomLeftButton1, "BOTTOMLEFT", 0, PET_Y, nil) MoveElement(_G.MainMenuBarVehicleLeaveButton, nil, "BOTTOMLEFT", _G.MultiBarBottomLeftButton12, "BOTTOMRIGHT", 0, PET_Y + 30 + 6, nil) for i = 1, _G.NUM_STANCE_SLOTS do if _G["StanceButton"..i]:GetNormalTexture():GetWidth() ~= 52 then _G["StanceButton"..i]:GetNormalTexture():SetWidth(52) _G["StanceButton"..i]:GetNormalTexture():SetHeight(52) end end end
hooksecurefunc("UIParent_ManageFramePositions", OverridePosit)
hooksecurefunc("MultiActionBar_Update", OverridePosit)
hooksecurefunc("MainMenuBarVehicleLeaveButton_Update", OverridePosit)
hooksecurefunc("PetActionBar_Update", OverridePosit)
hooksecurefunc("StanceBar_Update", OverridePosit)
hooksecurefunc("PossessBar_Update", OverridePosit)
hooksecurefunc("OverrideActionBar_Leave", function() _G.PetActionBarFrame:Show() end)
hooksecurefunc("MultiActionBar_UpdateGridVisibility", function() if InCombatLockdown() then return end for i = 1, _G.NUM_ACTIONBAR_BUTTONS do local button = _G["ActionButton"..i] if _G.ALWAYS_SHOW_MULTIBARS == "1" or _G.ALWAYS_SHOW_MULTIBARS == 1 then button:SetAttribute("showgrid", 1) ActionButton_ShowGrid(button) else button:SetAttribute("showgrid", 0) ActionButton_HideGrid(button) end end end)
for _, tex in next, { "_BG", "EndCapL", "EndCapR", "_Border", "Divider1", "Divider2", "Divider3", "ExitBG", "MicroBGL", "MicroBGR", "_MicroBGMid", "ButtonBGL", "ButtonBGR", "_ButtonBGMid" } do _G.OverrideActionBar[tex]:Hide() end
local HideOverride = CreateFrame("frame")
HideOverride:Hide()
for _, f in next, { _G.OverrideActionBarExpBar, _G.OverrideActionBarHealthBar, _G.OverrideActionBarPowerBar, _G.OverrideActionBarPitchFrame } do f:SetParent(HideOverride)end
for i = 1, 6 do local button = _G.OverrideActionBar["SpellButton"..i] if not button then break end button:ClearAllPoints() if i == 1 then button:SetPoint("BOTTOMLEFT", _G.ActionButton1) else button:SetPoint("LEFT", _G.OverrideActionBar["SpellButton"..i-1], "RIGHT", 6, 0) end end
_G.OverrideActionBar.LeaveButton:ClearAllPoints()
_G.OverrideActionBar.LeaveButton:SetPoint("CENTER", _G.UIParent, "CENTER", 0, 0)
--
-- CHAT
--
_G.ChatFrame1:ClearAllPoints()
_G.ChatFrame1:SetPoint("BOTTOMLEFT", "UIParent", "BOTTOMLEFT", 8, 48)
local function DoNothing() end
ChatFrame1.ClearAllPoints = DoNothing
ChatFrame1.SetPoint = DoNothing
_G.ChatFrame1:SetUserPlaced(true)
for i = 1, _G.NUM_CHAT_WINDOWS do _G["ChatFrame"..i.."EditBoxLeft"]:SetAlpha(0) _G["ChatFrame"..i.."EditBoxRight"]:SetAlpha(0) _G["ChatFrame"..i.."EditBoxMid"]:SetAlpha(0) _G["ChatFrame"..i.."TabLeft"]:SetAlpha(0) _G["ChatFrame"..i.."TabRight"]:SetAlpha(0) _G["ChatFrame"..i.."TabMiddle"]:SetAlpha(0) end
for _, value in ipairs(_G.CHAT_FRAME_TEXTURES) do for i = 1, _G.NUM_CHAT_WINDOWS, 1 do _G["ChatFrame" .. i .. value]:Hide() _G["ChatFrame" .. i .. value].Show = function() end _G["ChatFrame" .. i .. value]:SetAlpha(0) _G["ChatFrame" .. i .. value].SetAlpha = function() end end end
--
-- UNITS FRAMES
--
MoveElement(_G.PlayerFrame, nil, "RIGHT", _G.UIParent, "CENTER", -160, -160, nil)
MoveElement(_G.TargetFrame, nil, "RIGHT", _G.UIParent, "CENTER", 160 + _G.TargetFrame:GetWidth(), -160)
MoveElement(_G.FocusFrame, nil, "RIGHT", _G.UIParent, "CENTER", 160 + _G.TargetFrame:GetWidth() + _G.FocusFrame:GetWidth(), -160, nil)
_G.PlayerFrame:SetUserPlaced(true)
_G.TargetFrame:SetUserPlaced(true)
_G.FocusFrame:SetUserPlaced(true)
_G.PlayerFrame.SetPoint = function() end
_G.TargetFrame.SetPoint = function() end
_G.FocusFrame.SetPoint = function() end
for i = 1, 5 do _G["Boss"..i.."TargetFrame"]:SetScale(1.25) end
--
-- MINIMAP
--
_G.MiniMapTrackingButton:SetScript("OnMouseDown", function(self, btn) if btn == "RightButton" then _G.GameTimeFrame:Click() end end) _G.Minimap:EnableMouseWheel(true) _G.Minimap:SetScript('OnMouseWheel', function(self, delta) if delta > 0 then Minimap_ZoomIn() else Minimap_ZoomOut() end end)
_G.GarrisonLandingPageMinimapButton:SetScale(0.7)
--
-- MISC
--
-- HIDE TALKING HEAD
if LoadAddOn("Blizzard_TalkingHeadUI") then _G.TalkingHeadFrame:SetScript("OnShow", nil) _G.TalkingHeadFrame:SetScript("OnHide", nil) _G.TalkingHeadFrame:UnregisterAllEvents() end
-- HIDE BOSS BANNER (RAID LOOT FRAME)
_G.BossBanner:UnregisterAllEvents()
-- HIDE ORDER HALL BAR
hooksecurefunc("OrderHall_LoadUI", function() if _G.OrderHallCommandBar then _G.OrderHallCommandBar:SetScript("OnShow", nil) _G.OrderHallCommandBar:SetScript("OnHide", nil) _G.OrderHallCommandBar:UnregisterAllEvents() end end)
hooksecurefunc("OrderHall_CheckCommandBar", function() if _G.OrderHallCommandBar then _G.OrderHallCommandBar:Hide() end end)